pro subtract_offsets, file_scalars, flux, base, maxnoise_subs=maxnoise_subs, galactic=galactic



;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


restore, file_scalars

nt_flux = n_elements(flux(*, 0))
nt_base = n_elements(base(*, 0))


off = median(flux, dimension=1)
wb = where(finite(maxnoise_subs) gt 0 and total(finite(flux), 1) gt nt_flux / 4L, cb)
if keyword_set(galactic) then if cb ge 10L then begin
   sig = flux(*, wb)
   min_sb = min(sig, /nan)
   w = where(finite(sig) lt 1, cw)
   if cw ge 1 then sig(w) = min_sb - 100.
   med_wn = median(maxnoise_subs) / 3.
   h2 = hist_2d(sig, findgen(cb) ## (1. + fltarr(nt_flux)), min1=min_sb, bin1=med_wn)
   n_bin = n_elements(h2(*, 0))
   sb = min_sb + med_wn * findgen(n_bin)
   m = max(h2, dimension=1, ind)
   off(wb) = min([[sb(ind mod n_bin)], [median(flux(*, wb), dimension=1)]], dimension=2)
endif

w = where(finite(off) gt 0, cw)
if cw ge 1 then begin
   flux(*, w) -= (off(w) ## (1. + fltarr(nt_flux)))
   base(*, w) += (off(w) ## (1. + fltarr(nt_base)))
endif

end
