pro batch_process_artemis, master_list=master_list


;;; to run Scanamorphos for ArT\'eMiS in batch mode
;;; inputs in the ascii file master_list (give its full path)
;;; for each field: journal saved in output directory = input directory

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



resolve_all, /continue_on_error, /quiet


crs = string(13b) + string(10b)



;;; loop on fields:

openr, 9, master_list
repeat begin

   file_out = ''
   readf, 9, format='(A)', file_out
   file_out = strcompress(file_out, /remove_all)
   dir_in = ''
   readf, 9, format='(A)', dir_in
   dir_in = strtrim(dir_in, 2)
   nc = strlen(dir_in)
   if strmid(dir_in, nc-1) ne '/' then dir_in = dir_in + '/'

   options = ", /batch, file_out='" + file_out + "'"
   options = options + ", dir_scanlist='" + dir_in + "'"

   input = ' '
   while (not eof(9) and strmid(input, 0, 1) ne '#') do begin
      readf, 9, format='(A)', input
      if (strmid(input, 0, 1) ne '#' and strmid(input, 0, 1) ne ';') $
         then options = options + ", " + input
   endwhile

   print, crs + '##############################' + crs
   print, file_out + crs
   file_log = dir_in + file_out + '.log'
   test = file_test(file_log)
   ind = 1
   if test eq 1 then repeat begin
      ind += 1
      file_log = dir_in + file_out + '_' + chain(ind) + '.log'
      test = file_test(file_log)
   endrep until test eq 0
   journal, file_log
   flag = execute("scanam_artemis" + options)
   journal
   clean_log, file=file_log

endrep until eof(9)
close, 9


end
